package model

type Class struct {
	Id           int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	Name         string `json:"name" xorm:"not null default '' comment('名称') VARCHAR(255)"`
	Memo         string `json:"memo" xorm:"not null default '' comment('备注') VARCHAR(255)"`
	GradeId      int    `json:"grade_id" xorm:"not null default 0 comment('年级id') INT(11)"`
	EnterpriseId int    `json:"enterprise_id" xorm:"not null default 0 comment('单位id') INT(11)"`
	Sort         int    `json:"sort" xorm:"not null default 0 comment('排序') TINYINT(3)"`
	CreateAt     string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt     string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
