package model

type Merchant struct {
	Id           int    `json:"id" xorm:"not null pk autoincr INT(11)"`
	Name         string `json:"name" xorm:"not null default '' comment('商家名称') VARCHAR(255)"`
	EnterpriseId int    `json:"enterprise_id" xorm:"not null default 0 comment('校企id') INT(11)"`
	CreateAt     string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt     string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
