package enum

type NursingHomeUserRefundDayState int32

const (
	NursingHomeUserRefundDayStateForAuditing      = 1
	NursingHomeUserRefundDayStateForAuditPass     = 2
	NursingHomeUserRefundDayStateForAuditReject   = 3
	NursingHomeUserRefundDayStateForAuditComplete = 4
)

func (gt NursingHomeUserRefundDayState) String() string {
	switch gt {
	case NursingHomeUserRefundDayStateForAuditing:
		return "审核中"
	case NursingHomeUserRefundDayStateForAuditPass:
		return "审核通过"
	case NursingHomeUserRefundDayStateForAuditReject:
		return "审核拒绝"
	case NursingHomeUserRefundDayStateForAuditComplete:
		return "退款已完成"
	default:
		return "未知"
	}
}
