package model

type CentralKitchenWxTransferOrdList struct {
	Id             int    `json:"id" xorm:"not null pk autoincr INT"`
	Uid            int    `json:"uid" xorm:"not null default 0 comment('uid') INT"`
	OutTradeNo     string `json:"out_trade_no" xorm:"not null default '' comment('商家批次单号') CHAR(50)"`
	OutDetailNo    string `json:"out_detail_no" xorm:"not null default '' comment('商家明细单号') CHAR(50)"`
	TransferRemark string `json:"transfer_remark" xorm:"not null default '' comment('转账备注') CHAR(50)"`
	TransferAmount string `json:"transfer_amount" xorm:"not null default 0.00 comment('转账金额') DECIMAL(6,2)"`
	Openid         string `json:"openid" xorm:"not null default '' comment('收款用户openid') CHAR(50)"`
	CreateAt       string `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt       string `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
}
